
# Linux Stuff

[ -r /etc/debian_version ] && source $DOTZSHDIR/os.d/Debian.zsh

if [ "$TERM" != "dumb" ]; then
    if [ -r "$DOTZSHDIR/config/dircolors" ]; then
	eval $(dircolors -b $DOTZSHDIR/config/dircolors)
    else
	eval $(dircolors -b)
    fi
    alias ls="ls -h --color=auto"
    alias l="ls -lh --color=auto"
else
    alias ls="ls -h"
    alias l="ls -lh"
fi

